Subject: [Anima] draft-carpenter-anima-grasp-bulk discussion

From: Brian E Carpenter <[email-masked]>
Date: Mon, 23 Apr 2018 13:28:59 +1200

> 6.Transferring Bulk Data over the GRASP - 10min
>    10:55 - 11:05, by Bing Liu, draft-carpenter-anima-grasp-bulk
> 
> [Sheng] I see use cases of this, e.g. IoT device software/firmware update. But 
>    I'm not sure why you have the MTU as 2000 byte?
> [Bing] It is mostly for convenience of parsing the GRASP messages because under 
>    layer is CBOR serialization, a fixed 2000 byte is easy to identify the end
>    of the message.

At some point in the design of GRASP it became clear that a default
maximum message size was a practical requirement. The choice of 2048
was made in draft-ietf-anima-grasp-08. Discussion thread at:
https://mailarchive.ietf.org/arch/msg/anima/y-WC1sUFYJ6f_gBALzrg6M4obvE
The practical impact is the buffer size you set for recvfrom(). Also,
there will be a physical limit for UDP multicast. The GRASP spec says:

   GRASP nodes MUST be able to receive unicast messages of at least
   GRASP_DEF_MAX_SIZE bytes.  GRASP nodes MUST NOT send unicast messages
   longer than GRASP_DEF_MAX_SIZE bytes unless a longer size is
   explicitly allowed for the objective concerned.  For example, GRASP
   negotiation itself could be used to agree on a longer message size.

So it would be quite legal for bulk transfer to negotiate a larger
size. (I had forgotten that when Joel raised this issue.)

   Brian